add_defines("SOL_SAFE_FUNCTION")

i = 0
nextAvailableTime = os.time() + 5
prevItemQuantity = 0

local alcoholItems = {
	"Items.GoodQualityAlcohol1",
	"Items.GoodQualityAlcohol2",
	"Items.GoodQualityAlcohol3",
	"Items.GoodQualityAlcohol4",
	"Items.GoodQualityAlcohol5",
	"Items.GoodQualityAlcohol6",
	"Items.LowQualityAlcohol1",
	"Items.LowQualityAlcohol2",
	"Items.LowQualityAlcohol3",
	"Items.LowQualityAlcohol4",
	"Items.LowQualityAlcohol5",
	"Items.LowQualityAlcohol6",
	"Items.LowQualityAlcohol7",
	"Items.LowQualityAlcohol8",
	"Items.LowQualityAlcohol9",
	"Items.MediumQualityAlcohol1",
	"Items.MediumQualityAlcohol2",
	"Items.MediumQualityAlcohol3",
	"Items.MediumQualityAlcohol4",
	"Items.MediumQualityAlcohol5",
	"Items.MediumQualityAlcohol6",
	"Items.MediumQualityAlcohol7",
	"Items.NomadsAlcohol1",
	"Items.NomadsAlcohol2",
	"Items.TopQualityAlcohol1",
	"Items.TopQualityAlcohol2",
	"Items.TopQualityAlcohol3",
	"Items.TopQualityAlcohol4",
	"Items.TopQualityAlcohol5",
	"Items.TopQualityAlcohol6",
	"Items.TopQualityAlcohol7"
}

local drinkItems = {
	"Items.GoodQualityDrink1",
	"Items.GoodQualityDrink11",
	"Items.GoodQualityDrink2",
	"Items.GoodQualityDrink3",
	"Items.GoodQualityDrink4",
	"Items.GoodQualityDrink5",
	"Items.GoodQualityDrink6",
	"Items.GoodQualityDrink7",
	"Items.GoodQualityDrink8",
	"Items.GoodQualityDrink9",
	"Items.LowQualityDrink1",
	"Items.LowQualityDrink10",
	"Items.LowQualityDrink11",
	"Items.LowQualityDrink12",
	"Items.LowQualityDrink13",
	"Items.LowQualityDrink2",
	"Items.LowQualityDrink3",
	"Items.LowQualityDrink4",
	"Items.LowQualityDrink5",
	"Items.LowQualityDrink6",
	"Items.LowQualityDrink7",
	"Items.LowQualityDrink8",
	"Items.LowQualityDrink9",
	"Items.MediumQualityDrink1",
	"Items.MediumQualityDrink10",
	"Items.MediumQualityDrink11",
	"Items.MediumQualityDrink12",
	"Items.MediumQualityDrink13",
	"Items.MediumQualityDrink14",
	"Items.MediumQualityDrink2",
	"Items.MediumQualityDrink3",
	"Items.MediumQualityDrink4",
	"Items.MediumQualityDrink5",
	"Items.MediumQualityDrink6",
	"Items.MediumQualityDrink7",
	"Items.MediumQualityDrink8",
	"Items.MediumQualityDrink9",
	"Items.NomadsDrink1",
	"Items.NomadsDrink2"
}

local foodItems = {
	"Items.GoodQualityFood1",
	"Items.GoodQualityFood10",
	"Items.GoodQualityFood11",
	"Items.GoodQualityFood12",
	"Items.GoodQualityFood13",
	"Items.GoodQualityFood2",
	"Items.GoodQualityFood3",
	"Items.GoodQualityFood4",
	"Items.GoodQualityFood5",
	"Items.GoodQualityFood6",
	"Items.GoodQualityFood7",
	"Items.GoodQualityFood8",
	"Items.GoodQualityFood9",
	"Items.LowQualityFood1",
	"Items.LowQualityFood10",
	"Items.LowQualityFood11",
	"Items.LowQualityFood12",
	"Items.LowQualityFood13",
	"Items.LowQualityFood14",
	"Items.LowQualityFood15",
	"Items.LowQualityFood16",
	"Items.LowQualityFood17",
	"Items.LowQualityFood18",
	"Items.LowQualityFood19",
	"Items.LowQualityFood20",
	"Items.LowQualityFood21",
	"Items.LowQualityFood22",
	"Items.LowQualityFood23",
	"Items.LowQualityFood24",
	"Items.LowQualityFood25",
	"Items.LowQualityFood26",
	"Items.LowQualityFood27",
	"Items.LowQualityFood28",
	"Items.LowQualityFood3",
	"Items.LowQualityFood5",
	"Items.LowQualityFood6",
	"Items.LowQualityFood7",
	"Items.LowQualityFood8",
	"Items.LowQualityFood9",
	"Items.MediumQualityFood1",
	"Items.MediumQualityFood10",
	"Items.MediumQualityFood11",
	"Items.MediumQualityFood12",
	"Items.MediumQualityFood13",
	"Items.MediumQualityFood14",
	"Items.MediumQualityFood15",
	"Items.MediumQualityFood17",
	"Items.MediumQualityFood18",
	"Items.MediumQualityFood19",
	"Items.MediumQualityFood2",
	"Items.MediumQualityFood20",
	"Items.MediumQualityFood3",
	"Items.MediumQualityFood4",
	"Items.MediumQualityFood5",
	"Items.MediumQualityFood6",
	"Items.MediumQualityFood7",
	"Items.MediumQualityFood8",
	"Items.MediumQualityFood9",
	"Items.NomadsFood1",
	"Items.NomadsFood2",
}
	
registerForEvent("onUpdate", function()

    if (nextAvailableTime < os.time()) then
		nextAvailableTime = os.time() + 5
		
		--dirty check to see if the player in in world
		--and not in loading screen or start meenu
		player = Game.GetPlayer()
		ts = Game.GetTransactionSystem()
		currentItemQuantity = ts:GetTotalItemQuantity(player)
		
		if(prevItemQuantity ~= currentItemQuantity ) then
			MyMod:ProccessConsumable()
		end
		
    end

end)

MyMod = { description = "Declutter Food and Beverages" }

function MyMod:new()
    o = {}
    setmetatable(o, self)
    self.__index = self
    self.description = "Declutter Food and Beverages"
	
    return o
end

function MyMod:ProccessConsumable()
	ts = Game.GetTransactionSystem()
	player = Game.GetPlayer()
	
	------------------------------------------------------------------------------------------------------
	--
	--Count how many drinks the player has not counting GoodQualityDrink1
	--GoodQualityDrink10 = Water
	--Count how much food the player has not counting MediumQualityFood16 (those are Tacos, choombas like Tacos)
	--MediumQualityFood16 = Taco
	
	totalDrinks = 0
	totalTacos = 0
	
	for i,v in ipairs(alcoholItems) do
		tid = TweakDBID.new(v)
		itemid = GetSingleton("gameItemID"):FromTDBID(tid)
		currentDrinkCount = ts:GetItemQuantity(player, itemid)
		if currentDrinkCount > 0 then
			--alcohol price = $30
			moneyToAdd = 30 * currentDrinkCount
			print("Gained Eurodollars: ", moneyToAdd)
			Game.AddToInventory("Items.money",moneyToAdd)
			
			ts:RemoveItem(player, itemid, currentDrinkCount)
		end
	end
	
	for i,v in ipairs(drinkItems) do
		tid = TweakDBID.new(v)
		itemid = GetSingleton("gameItemID"):FromTDBID(tid)
		currentDrinkCount = ts:GetItemQuantity(player, itemid)
		if currentDrinkCount > 0 then
			ts:RemoveItem(player, itemid, currentDrinkCount)
			totalDrinks = totalDrinks + currentDrinkCount
		end
	end
	
	for i,v in ipairs(foodItems) do
		tid = TweakDBID.new(v)
		itemid = GetSingleton("gameItemID"):FromTDBID(tid)
		currentFoodCount = ts:GetItemQuantity(player, itemid)
		if currentFoodCount > 0 then
			ts:RemoveItem(player, itemid, currentFoodCount)
			totalTacos = totalTacos + currentFoodCount
		end
	end
	
	if(totalDrinks > 0) then
		Game.AddToInventory("Items.GoodQualityDrink10", totalDrinks)
	end
	
	if(totalTacos > 0) then
		Game.AddToInventory("Items.MediumQualityFood16", totalTacos)
	end
	
	--DEBUG
	print("Water added: ", totalDrinks)
	print("Tacos added: ", totalTacos)
	print("nextAvailableTime: ", nextAvailableTime)
	print("CurrentTotalItemQuantity: ", ts:GetTotalItemQuantity(player))
	print("PrevTotalItemQuantity: ", prevItemQuantity)
	print("")
	
	--update previuos total quantity value
	prevItemQuantity = ts:GetTotalItemQuantity(player)
end

return MyMod:new()